<?php 

if (!defined('FORUM')) die();

if (isset($_GET['reinstall']))
{
	$id = preg_replace('/[^0-9a-z_]/', '', $_GET['reinstall']);

	//include language file
	if (file_exists($ext_info['path'].'/lang/'.$forum_user['language'].'/'.$ext_info['id'].'.php'))
		require $ext_info['path'].'/lang/'.$forum_user['language'].'/'.$ext_info['id'].'.php';
	else
		require $ext_info['path'].'/lang/English/'.$ext_info['id'].'.php';

	// We validate the CSRF token. If it's set in POST and we're at this point, the token is valid.
	// If it's in GET, we need to make sure it's valid.
	if (!isset($_POST['csrf_token']) && (!isset($_GET['csrf_token']) || $_GET['csrf_token'] !== generate_form_token('reinstall'.$id)))
		csrf_confirm_form();

	// Setup breadcrumbs
	$forum_page['crumbs'] = array(
		array($forum_config['o_board_title'], forum_link($forum_url['index'])),
		array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index'])),
		$lang_admin_common['Manage extensions']
	);

	if (isset($_POST['reinstall_cancel']))
	{
		$display_group_buttons = true;
		include $ext_info['path'].'/extension_list.php';
	}
	else
	{
		//Check for dependencies first
		$query = array(
			'SELECT'	=> 'e.id',
			'FROM'		=> 'extensions AS e',
			'WHERE'		=> 'e.disabled=0 AND e.dependencies LIKE \'%'.$forum_db->escape($id).'%\''
		);

		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

		if ($forum_db->num_rows($result))
		{
			$dependency = $forum_db->fetch_assoc($result);
			$head_notice = sprintf($lang_pun_man_ext_improved['Reinstall ext'], $id);
			$important_message = sprintf($lang_pun_man_ext_improved['Reinstall with deps'], $dependency['id'], '"'.$id.'"');
			$type = 'reinstall';
			$handle = $base_url.'/admin/extensions.php?section=manage&amp;reinstall='.$id;
		
			include  $ext_info['path'].'/continue.php';	
		}
	}

	// Fetch info about the extension
	$query = array(
		'SELECT'	=> 'e.title, e.version, e.description, e.author, e.uninstall, e.uninstall_note',
		'FROM'		=> 'extensions AS e',
		'WHERE'		=> 'e.id=\''.$forum_db->escape($id).'\''
	);

	($hook = get_hook('aex_qr_get_extension')) ? eval($hook) : null;

	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	if (!$forum_db->num_rows($result))
		message($lang_common['Bad request']);

	$old_ext_data = $forum_db->fetch_assoc($result);

	// Load manifest (either locally or from punbb.informer.com updates service)
	if (strpos($id, 'hotfix_') === 0)
		$manifest = @end(get_remote_file('http://punbb.informer.com/update/manifest/'.$id.'.xml', 16));
	else
		$manifest = @file_get_contents(FORUM_ROOT.'extensions/'.$id.'/manifest.xml');

	// Parse manifest.xml into an array and validate it
	$ext_data = xml_to_array($manifest);
	$errors = validate_manifest($ext_data, $id);

	if (!isset($_POST['reinstall_continue']) && isset($_GET['only_hoks']) && version_compare($ext_data['extension']['version'], $old_ext_data['version'], '>'))
	{
		//Show continue page
		$important_message = sprintf($lang_pun_man_ext_improved['Update error'], $id);
		$head_notice = $lang_pun_man_ext_improved['Ext update'];
		$type = 'reinstall';
		$handle = $base_url.'/admin/extensions.php?section=manage&amp;multy&amp;only_hoks&amp;reinstall='.$id;

		include $ext_info['path'].'/continue.php';
	}
	if (!empty($errors))
		message(isset($_GET['install']) ? $lang_common['Bad request'] : $lang_admin_common['Hotfix download failed']);

	// Is there some uninstall code to store in the db?
	$uninstall_code = (isset($ext_data['extension']['uninstall']) && trim($ext_data['extension']['uninstall']) != '') ? '\''.$forum_db->escape(trim($ext_data['extension']['uninstall'])).'\'' : 'NULL';

	// Is there an uninstall note to store in the db?
	$uninstall_note = 'NULL';
	foreach ($ext_data['extension']['note'] as $cur_note)
	{
		if ($cur_note['attributes']['type'] == 'uninstall' && trim($cur_note['content']) != '')
			$uninstall_note = '\''.$forum_db->escape(trim($cur_note['content'])).'\'';
	}
	// Run uninstall + install only if all previous steps are OK

	
	// Run uninstall code
	if (!isset($_GET['only_hoks'])){
		$last_ext_info = $ext_info;
		// Prevent errors when include files in the uninstall section
		$ext_info = array('path' => FORUM_ROOT.'extensions/'.$id);
		eval($old_ext_data['uninstall']);
		$ext_info = $last_ext_info;
	}

	// Now delete the extension and its hooks from the db
	$query = array(
		'DELETE'	=> 'extension_hooks',
		'WHERE'		=> 'extension_id = \''.$forum_db->escape($id).'\''
	);
	
	($hook = get_hook('aex_qr_uninstall_delete_hooks')) ? eval($hook) : null;
	
	$forum_db->query_build($query) or error(__FILE__, __LINE__);

	$query = array(
		'DELETE'	=> 'extensions',
		'WHERE'	 => 'id = \''.$forum_db->escape($id).'\''
	);

	($hook = get_hook('aex_qr_delete_extension')) ? eval($hook) : null;

	$forum_db->query_build($query) or error(__FILE__, __LINE__);

	require_once $ext_info['path'].'/functions.php';

	regenerate_glob_vars();

	// Run the author supplied install code
	if (isset($ext_data['extension']['install']) && trim($ext_data['extension']['install']) != '' && !isset($_GET['only_hoks'])) {
		$last_ext_info = $ext_info;
		// Prevent errors when include files in the install section
		$ext_info = array('path' => FORUM_ROOT.'extensions/'.$id);
		eval($ext_data['extension']['install']);
		$ext_info = $last_ext_info;
	}

	// Make sure we have an array of dependencies
	if (!isset($ext_data['extension']['dependencies']))
		$ext_data['extension']['dependencies'] = array();
	else if (!is_array(current($ext_data['extension']['dependencies'])))
		$ext_data['extension']['dependencies'] = array($ext_data['extension']['dependencies']['dependency']);
	else
		$ext_data['extension']['dependencies'] = $ext_data['extension']['dependencies']['dependency'];

	// Add the new extension
	$query = array(
		'INSERT'	=> 'id, title, version, description, author, uninstall, uninstall_note, dependencies',
		'INTO'		=> 'extensions',
		'VALUES'	=> '\''.$forum_db->escape($ext_data['extension']['id']).'\', \''.$forum_db->escape($ext_data['extension']['title']).'\', \''.$forum_db->escape($ext_data['extension']['version']).'\', \''.$forum_db->escape($ext_data['extension']['description']).'\', \''.$forum_db->escape($ext_data['extension']['author']).'\', '.$uninstall_code.', '.$uninstall_note.', \'|'.implode('|', $ext_data['extension']['dependencies']).'|\'',
	);
	
	($hook = get_hook('aex_qr_add_ext')) ? eval($hook) : null;
	
	$forum_db->query_build($query) or error(__FILE__, __LINE__);

	// Now insert the hooks
	foreach ($ext_data['extension']['hooks']['hook'] as $ext_hook)
	{
		$cur_hooks = explode(',', $ext_hook['attributes']['id']);
		foreach ($cur_hooks as $cur_hook)
		{
			$query = array(
				'INSERT'	=> 'id, extension_id, code, installed, priority',
				'INTO'		=> 'extension_hooks',
				'VALUES'	=> '\''.$forum_db->escape(trim($cur_hook)).'\', \''.$forum_db->escape($id).'\', \''.$forum_db->escape(trim($ext_hook['content'])).'\', '.time().', '.(isset($ext_hook['attributes']['priority']) ? $ext_hook['attributes']['priority'] : 5)
			);
			
			($hook = get_hook('aex_qr_add_hook')) ? eval($hook) : null;
			
			$forum_db->query_build($query) or error(__FILE__, __LINE__);
		}
	}

	// Refresh system after install

	regenerate_glob_vars();

	// Regenerate the hooks cache
	require_once FORUM_ROOT.'include/cache.php';
	generate_config_cache();
	generate_hooks_cache();

	$display_group_buttons = true;

	include $ext_info['path'].'/extension_list.php';
}

$display_group_buttons = true;

if (isset($_GET['multy']) && (isset($_POST['disable_selected']) || isset($_POST['enable_selected']) || isset($_POST['uninstall_selected'])) && (!isset($_POST['extens']) || !is_array(array_keys($_POST['extens'])) || array_keys($_POST['extens']) == array()))
	$no_selected_extensions = true;
else if (isset($_GET['multy']))
{
	if (file_exists($ext_info['path'].'/lang/'.$forum_user['language'].'/'.$ext_info['id'].'.php'))
		require $ext_info['path'].'/lang/'.$forum_user['language'].'/'.$ext_info['id'].'.php';
	else
		require $ext_info['path'].'/lang/English/'.$ext_info['id'].'.php';

	if ((isset($_GET['disable_sel']) || isset($_GET['enable_sel']) || isset($_GET['uninstall_sel'])) && (!isset($_POST['selected_extens']) || !is_scalar($_POST['selected_extens']))) {
		$forum_flash->add_info($lang_pun_man_ext_improved['Input error']);
		redirect(forum_link($forum_url['admin_extensions_manage']), $lang_pun_man_ext_improved['Input error']);
	}

	if (!isset($_POST['csrf_token']))
		csrf_confirm_form();

	require_once $ext_info['path'].'/functions.php';
	
	//Working with list of selected extensions
	$sel_extens = validate_ext_list(isset($_POST['extens']) ? array_keys($_POST['extens']) : explode(',', $_POST['selected_extens']));
	if (empty($sel_extens))
		$no_selected_extensions = true;
	else
	{
		$selected_key = is_key_exists($_POST, array('disable_selected', 'enable_selected', 'uninstall_selected'));
		if ($selected_key)
		{
			$type = substr($selected_key, 0, -9);
			eval('$dependencies_error = get_dependencies_error_'.$type.'($sel_extens);');
			if (!empty($dependencies_error))
				$continue_page = true;
			else
			{
				switch ($type)
				{
					case 'enable':
						flip_extensions('0', $sel_extens);
						break;
					case 'disable':
						flip_extensions('1', $sel_extens);
						break;
					case 'uninstall':
						uninstall_extensions($sel_extens);
						$forum_flash->add_info($lang_pun_man_ext_improved['Uninstall selected']);
						redirect(forum_link($forum_url['admin_extensions_manage']), $lang_pun_man_ext_improved['Uninstall selected']);
						break;
				}
			}
		}
		//Continue disable selected
		else if (isset($_GET['disable_sel']) && isset($_POST['disable_continue']))
		{
			if (!isset($_POST['disable_type']) || ($_POST['disable_type'] != 0 && $_POST['disable_type'] != 1))
				message($lang_common['Bad request']);

			if ($_POST['disable_type'] == 0)
				flip_extensions('1', $sel_extens);
			else
			{
				flip_extensions('1', $sel_extens);
				$dependencies_error = get_dependencies_error_disable($sel_extens);
				if (!empty($dependencies_error))
				{
					$disable_dep_exts = array();
					foreach ($dependencies_error as $dep_ext => $main_exts)
					{
						if (!in_array($dep_ext, $sel_extens) && array_intersect($main_exts, $sel_extens) != array())
							$disable_dep_exts[] = $dep_ext;
					}
					flip_extensions('1', $disable_dep_exts);
				}
			}

			$forum_flash->add_info($lang_pun_man_ext_improved['Disable selected']);
			redirect(forum_link($forum_url['admin_extensions_manage']), $lang_pun_man_ext_improved['Disable selected']);
		}
		//Continue enable selected
		else if (isset($_GET['enable_sel']) && isset($_POST['enable_continue']))
		{
			if (!isset($_POST['enable_type']) || ($_POST['enable_type'] != 0 && $_POST['enable_type'] != 1))
				message($lang_common['Bad request']);

			if (!$_POST['enable_type'])
				flip_extensions('0', $sel_extens);
			else
			{
				flip_extensions('0', $sel_extens);
				$dependencies_error = get_dependencies_error_enable($sel_extens);
				if (!empty($dependencies_error))
				{
					$disable_dep_exts = array();
					foreach ($dependencies_error as $dep_ext => $main_exts)
					{
						foreach ($main_exts as $ext)
							$disable_dep_exts[] = $ext;
					}
					flip_extensions('0', array_unique($disable_dep_exts));
				}
			}
			$forum_flash->add_info($lang_pun_man_ext_improved['Enable selected']);
			redirect(forum_link($forum_url['admin_extensions_manage']), $lang_pun_man_ext_improved['Enable selected']);
		}
		//Continue uninstall selected
		else if (isset($_GET['uninstall_sel']) && isset($_POST['uninstall_continue']))
		{
			if (!isset($_POST['uninstall_type']) || !in_array($_POST['uninstall_type'], array(0, 1, 2)))
				message($lang_common['Bad request']);

			if ($_POST['uninstall_type'] == 0)
				uninstall_extensions( $sel_extens );
			else if ($_POST['uninstall_type'] == 1 || $_POST['uninstall_type'] == 2)
			{
				uninstall_extensions($sel_extens);
				$dependencies_error = get_dependencies_error_uninstall($sel_extens);

				if ($_POST['uninstall_type'] == 1)
					flip_extensions('1', array_keys($dependencies_error));
				else
					uninstall_extensions(array_keys($dependencies_error));
			}

			$forum_flash->add_info($lang_pun_man_ext_improved['Uninstall selected']);
			redirect(forum_link($forum_url['admin_extensions_manage']), $lang_pun_man_ext_improved['Uninstall selected']);
		}
	}

	if (isset($continue_page))
	{
		$display_group_buttons = false;
		include $ext_info['path'].'/continue.php';
	}
}
if ($section == 'manage')
	include $ext_info['path'].'/extension_list.php';
